
.text
.globl	find_max
.type	find_max, @function

find_max:
    # Fix up the stack frame
    pushl %ebp

    # Put first parameter in %ebx
    movl 8(%esp), %ebx
    # Put second parameter in %edx
    movl 12(%esp), %edx

    # Call the actual code
    jmp find_max_start

# Return from the function
function_return:
    pop %ebp
    ret

################################################
# THIS IS THE ACTUAL DEFINITION HERE
#
# find max procedure
# parameter: A pointer to the start of an int[]
#            in %ebx
# parameter: The length of the in int[]
#            in %edx
# return: the max of the array
#         in %eax
#
################################################

find_max_start:

    cmpl $0, %ebx     # Check to be sure the input is not null
    jne set_default   # If it is not 0, continue executing
    movl $0, %eax     # If the input was 0 (NULL) set the return value to 0
    jmp function_return

set_default:
    movl %ebx, %eax      #%eax now holds the pointer the base int
    movl (%eax), %ecx    #%ecx now holds the max we've seen so far

for_loop_init:
    movl $1, %ebx      # Move 0 into the loop counter

for_loop_compare:
    cmpl %ebx, %edx    # Compare loop counter to the length (%edx - %ebx)
    jle  set_return    # if , jump to return

for_loop_body:
    cmpl %ecx, (%eax,%ebx,4)   # Compare the current max to the current int
                               # current array value - current max
    cmovg (%eax,%ebx,4), %ecx  # conditionally move the int if the current array value
                               # is greater than the current max

for_loop_post:
    incl %ebx    # increment the loop counter
    jmp for_loop_compare

set_return:
    movl %ecx, %eax
    jmp function_return
